//decision making functions
char masterbrain();
int centreblank();
int firstblank();
void execution(struct cellinfo);

char masterbrain()
{
  /*
  this function is the ai core in which the actual decision is made
  the return value has no significance and is just to exit the function
  char return data type is used to minimize memory usage
  */
  struct cellinfo decision;
  int tempnull,noofnull=4,minfield=8;
  int i;

  //stupid or wise
  randomize();
  if (random(5)>diff)
  {
    tempnull=firstblank();
    decision.row=ROW(tempnull);
    decision.col=COL(tempnull);
    execution(decision);
    return(1);
  }

  //if centre is blank, occupy it...
  if (centreblank()==TRUE)
  {
    decision.row=1;
    decision.col=1;
    execution(decision);
    return(1);
  }
  else
  {
    //if you can win, do win...
    for (i=0;i<=7;i++)
    {
      if (status[i]==COMPUTER)
      {
	if (fieldfunc(i,'c')==1)
	{
	  tempnull=fieldfunc(i,'b');
	  decision.row=ROW(tempnull);
	  decision.col=COL(tempnull);
	  execution(decision);
	  return(1);
	}
      }
    }
    //if player can win, stop him...
    for (i=0;i<=7;i++)
    {
      if (status[i]==PLAYER)
      {
	if (fieldfunc(i,'c')==1)
	{
	  tempnull=fieldfunc(i,'b');
	  decision.row=ROW(tempnull);
	  decision.col=COL(tempnull);
	  execution(decision);
	  return(1);
	}
      }
    }
    //else, build your own...
    for (i=0;i<=7;i++)
    {
      if (status[i]==COMPUTER)
      {
	if (noofnull>(tempnull=fieldfunc(i,'c')))
	{
	  noofnull=tempnull;
	  minfield=i;
	}
      }
    }
    //execute own building decision...
    if (minfield!=8)
      tempnull=fieldfunc(minfield,'b');
    else
      tempnull=firstblank();

    decision.row=ROW(tempnull);
    decision.col=COL(tempnull);
    execution(decision);
    return(1);
  }
}

int centreblank()
{
  /*
  function to check if the centre is blank
  if blank, TRUE=0 is returned
  if not blank, FALSE=100 is returned
  */
  if (board[1][1]=='\0')
    return(TRUE);
  else
    return(FALSE);
}

int firstblank()
{
  /*
  function returns the cell index of the first blank cell
  if no cells are blank, returns the cell index of (3,3)
  */
  struct cellinfo cell;
  for (cell.row=0;cell.row<=2;cell.row++)
    for (cell.col=0;cell.col<=2;cell.col++)
      if (board[cell.row][cell.col]=='\0')
	return(CELLIND(cell.row,cell.col));
  return(CELLIND(3,3));
}

void execution(struct cellinfo cell)
{
  //void function to execute the ai decision...
  board[cell.row][cell.col]='O';
  updatecontrol(cell,COMPUTER);
  updatescreen();
}