//player interaction functions
void awaitplayerresponse();
void validateinput(int);
void stupidityalarm();

void awaitplayerresponse()
{
  /*
  void function to receive user input and pass it on for validation
  */

  int input;
  printf("\nEnter the cell no. to cross: ");
  scanf("%d",&input);
  fflush(stdin);  //fflush prevents crashes due to stupidity of user entries
  validateinput(input);
}

void validateinput(int input)
{
  /*
  this function checks user input for errors
  if errors are found, prompts user for re-entry of input
  if no errors found, marks appropriate cell
  */
  static int stupiditycount;

  struct cellinfo cell;
    cell.row=ROW(input);
    cell.col=COL(input);

  //if cell index is outside the range 1-9
  if (input<1 || input>9)
  {
    printf("Cell no must be within the range 1-9...");
    stupiditycount++;
    if (stupiditycount==3)
      stupidityalarm(), stupiditycount=0;
    awaitplayerresponse();
  }

  //avoid overwrite of cells
  else if (board[cell.row][cell.col]=='O' || board[cell.row][cell.col]=='X')
  {
    printf("Cell already marked...");
    stupiditycount++;
    if (stupiditycount==3)
      stupidityalarm(), stupiditycount=0;
    awaitplayerresponse();
  }

  //no errors... mark appropriate cell...
  else
  {
    board[cell.row][cell.col]='X';
    updatecontrol(cell,PLAYER);
    updatescreen();
  }
}

void stupidityalarm()
{
  //void function to display the stupidity alarm messages
  printf("\n\nCritical stupidity error\a.\a.\a.");
  sleep(1);
  printf("\nUser requested to exercise some intelligence");
  sleep(1);
  printf(".");
  sleep(1);
  printf(".");
  sleep(1);
  printf(".");
  getch();
  updatescreen();
}