void updatecontrol(struct cellinfo,int);
void updatestatus(int,int);
void checkforvictory();
int fieldfunc(int,char);

/*
CELL CONTROL UPDATION
if field is empty, change to resp. player
if field is owned by opponent, change to none

TRANSCODING CELL INFORMATION
field=row
field=col+3
else diagonals blah blah blah...
*/

void updatecontrol(struct cellinfo cell,int wru)
{
  /*
  this function calls updatestatus with
	properly processed arguments
  */

  //row control updation
  updatestatus(cell.row,wru);

  //col control updation
  updatestatus(cell.col+3,wru);

  //main diagonal control updation
  if (cell.row==cell.col)
    updatestatus(MAINDIAG,wru);

  //back diagonal control updation
  if ((cell.row+cell.col)==2)
    updatestatus(BACKDIAG,wru);
}

void updatestatus(int fieldind,int wru)
{
  /*
  this function accepts processed arguments from updatecontrol
	and does the actual updation of control
  */
  if (status[fieldind]==EMPTY)
    status[fieldind]=wru;
  else if (status[fieldind]!=wru)
    status[fieldind]=NONE;
}

void checkforvictory()
{
  /*
  this void function checks whether the player or the computer has won,
	takes appropriate action and
		exits execution of the program
  */
  int i;
  for (i=0;i<=7;i++)
  {
    //check for computer victory
    if (status[i]==COMPUTER)
    {
      if (fieldfunc(i,'c')==0)
      {
	fieldfunc(i,'v');
	updatescreen();
	printf("Computer wins...");
	getch();
	exit(EXIT_SUCCESS);
      }
    }
    //check for player victory
    else if (status[i]==PLAYER)
    {
      if (fieldfunc(i,'c')==0)
      {
	fieldfunc(i,'v');
	updatescreen();
	printf("Player wins!!!%c%c%c",1,1,1);
	getch();
	exit(EXIT_SUCCESS);
      }
    }
  }
}

int fieldfunc(int fieldind,char mode)
{

/*
this function inputs the field index as argument
	and depending on the mode, does three different operations
  mode 'c' - count nulls
	returns the no of nulls in the field
  mode 'b' - blank find
	returns the cell index of a blank cell in the field
  mode 'v' - add blink effect
	adds blink effect to the winning field cells

the default return(63) has no significance and
	is just to suppress the unreachable code warning
*/

  struct cellinfo cell;
  int ctr=0;
  switch (fieldind)
  {
    case 0:
    case 1:
    case 2:
      for (cell.col=2;cell.col>=0;cell.col--)
	if (board[fieldind][cell.col]=='\0')
	{
	  if (mode=='b')
	    return(CELLIND(fieldind,cell.col));
	  ctr++;
	}
	else if (mode=='v')
	  board[fieldind][cell.col]++;
      return(ctr);
    case 3:
    case 4:
    case 5:
      for (cell.row=2;cell.row>=0;cell.row--)
	if (board[cell.row][fieldind-3]=='\0')
	{
	  if (mode=='b')
	    return(CELLIND(cell.row,fieldind-3));
	  ctr++;
	}
	else if (mode=='v')
	  board[cell.row][fieldind-3]++;
      return(ctr);
    case 6:
      for (cell.row=0,cell.col=0;cell.row<=2;cell.row++,cell.col++)
	if (board[cell.row][cell.col]=='\0')
	{
	  if (mode=='b')
	    return(CELLIND(cell.row,cell.col));
	  ctr++;
	}
	else if (mode=='v')
	  board[cell.row][cell.col]++;
      return(ctr);
    case 7:
      for (cell.row=2,cell.col=0;cell.row>=0;cell.row--,cell.col++)
	if (board[cell.row][cell.col]=='\0')
	{
	  if (mode=='b')
	    return(CELLIND(cell.row,cell.col));
	  ctr++;
	}
	else if (mode=='v')
	  board[cell.row][cell.col]++;
      return(ctr);
    default:
      return(63);
  }
}